//
//  ViewControllerDashboard.swift
//  firebase-auth
//
//  Created by admin on 03.12.17.
//  Copyright © 2017 admin. All rights reserved.
//

import UIKit
import Firebase
import GoogleSignIn

class ViewControllerDashboard: UIViewController {

    @IBOutlet weak var userNameLabel: UILabel!
    @IBOutlet weak var lastLoginLabel: UILabel!
    @IBOutlet weak var photoImageView: UIImageView!
    
    @IBAction func logoutButton(_ sender: Any) {
        
        do{
            try Auth.auth().signOut();
            
        } catch let signOutError as NSError {
            print ("Error signing out: %@", signOutError)
        }
        
        let nextViewController =
            self.storyboard?.instantiateViewController(withIdentifier: "Login") as! ViewControllerLogin
        self.present(nextViewController, animated:true, completion:nil)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        if let user = Auth.auth().currentUser {
            self.userNameLabel.text = user.displayName
            self.lastLoginLabel.text = "Last Login: " + (user.metadata.lastSignInDate?.description)!
            if let photoURL = user.photoURL {
                self.photoImageView.image = UIImage(data: NSData(contentsOf: photoURL)! as Data)
            }
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

